

/****** Object : Table [dbo].[Service] Copyright TECK SYSTEM SOFT 2024 One ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Service] SET [Insert_Date] = '' WHERE [Insert_Date] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Service] SET [Customer] = '' WHERE [Customer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Service] SET [Site] = '' WHERE [Site] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Service] SET [Manager] = '' WHERE [Manager] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Service] SET [Severity] = '' WHERE [Severity] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Service] SET [Dashboard] = '' WHERE [Dashboard] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Service] SET [Domain] = '' WHERE [Domain] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Service] SET [Computer] = '' WHERE [Computer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Service] SET [Service] = '' WHERE [Service] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Service] SET [Status] = '' WHERE [Status] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Service] SET [Mode] = '' WHERE [Mode] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Service] SET [Alarm] = '' WHERE [Alarm] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Service] SET [Availability] = '' WHERE [Availability] IS NULL

 INSERT INTO [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityService]
([Insert_Date]
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
      ,[Service]
      ,[Status] 
      ,[Mode] 
      ,[Alarm]
	  ,[Availability]
)

SELECT  
[Insert_Date]
       ,[Customer]
       ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain] 
      ,[Computer]
      ,[Service]
      ,[Status] 
      ,[Mode] 
      ,[Alarm]
	  ,CONVERT(nvarchar(25),[Availability])
	  
FROM
(SELECT DISTINCT  CONVERT(nvarchar(25),[Insert_Date]) + '-' + [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Service] +  '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  AS SEARCH_STRING
	  ,[Insert_Date] 
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
      ,[Service]
      ,[Status] 
      ,[Mode]
      ,[Alarm]
      ,[Availability] 

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[Service]
WHERE [Availability] = '1' AND CONVERT(nvarchar(25),[Insert_Date]) + '-' + [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Service] +  '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability]) NOT IN 

(SELECT DISTINCT  CONVERT(nvarchar(25),[Insert_Date]) + '-' + [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Service] +  '-' + [Status] + '-' + [Alarm]  + '-' + CONVERT(nvarchar(10),[Availability]) AS SEARCH_STRING
FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityService]) ) TBL 

/****** Object : UPDATE existing entries with the lastest values ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityService] 
SET  [Status] = REQUEST.[Status],
     [Alarm] = REQUEST.[Alarm],
     [Availability] = REQUEST.[Availability]
     /*[Insert_Date] = REQUEST.[Insert_Date] -- Last UPDATE time */

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityService] SERVS,

/****** Object : Select values ******/

(SELECT TEMP_JOIN.[Service_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[Service],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Status],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Availability]

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[Service] TEMP
INNER JOIN  [Monitorpack_GuardReportsMonitorpack].[dbo].[Service] TEMP_JOIN 
ON TEMP_JOIN.[Mode] = TEMP.[Mode]

WHERE 
TEMP.[Customer] = TEMP_JOIN .[Customer] AND
TEMP.[Site] = TEMP_JOIN .[Site] AND
TEMP.[Domain] = TEMP_JOIN .[Domain] AND
TEMP.[Computer] = TEMP_JOIN .[Computer] AND
TEMP.[Service] =  TEMP_JOIN .[Service] AND
TEMP.[Mode] = TEMP_JOIN .[Mode] AND
TEMP.[Status] = TEMP_JOIN .[Status]AND
TEMP.[Alarm] = TEMP_JOIN .[Alarm] AND
TEMP.[Availability]=TEMP_JOIN.[Availability]
GROUP BY
TEMP_JOIN.[Service_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[Service],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Status],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Availability]

HAVING max(TEMP.Service_ID) = TEMP_JOIN.[Service_ID]) AS REQUEST

WHERE
SERVS.[Customer] = REQUEST.[Customer]
AND SERVS.[Site] = REQUEST.[Site]
AND SERVS.[Domain] = REQUEST.[Domain]
AND SERVS.[Computer] = REQUEST.[Computer]
AND SERVS.[Alarm] = REQUEST.[Alarm]
AND SERVS.[Status] = REQUEST.[Status]
AND SERVS.Availability = REQUEST.Availability
   
TRUNCATE TABLE [Monitorpack_GuardReportsMonitorpack].[dbo].[ServiceTemp] 